Update inventory by adding new property - Fabric

Update inventory by adding new property

cURL

curl --request PATCH \
  --url https://prod01.oms.fabric.inc/api/v2/inventory \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --header 'x-site-context: <x-site-context>' \
  --data '
{
  "sku": "SKU00025",
  "itemId": 4225678911,
  "locationNum": 473746,
  "channelId": 12,
  "vendorId": "vendor123",
  "leadTime": 1234,
  "inventoryType": "primary",
  "infiniteInventory": true,
  "backOrderDate": "2022-08-08T00:00:00.000Z",
  "preOrderDate": "2022-08-08T00:00:00.000Z",
  "backOrderLimit": 100,
  "preOrderLimit": 100,
  "safetyStock": 10,
  "lowStock": 10,
  "segment": "Clothing",
  "region": "US",
  "counters": {
    "on-hand": 10
  },
  "attributes": {
    "buy online, pick up in-store (bopis)": true
  }
}
'

Python Example

import requests

url = "https://prod01.oms.fabric.inc/api/v2/inventory"

payload = {
    "sku": "SKU00025",
    "itemId": 4225678911,
    "locationNum": 473746,
    "channelId": 12,
    "vendorId": "vendor123",
    "leadTime": 1234,
    "inventoryType": "primary",
    "infiniteInventory": True,
    "backOrderDate": "2022-08-08T00:00:00.000Z",
    "preOrderDate": "2022-08-08T00:00:00.000Z",
    "backOrderLimit": 100,
    "preOrderLimit": 100,
    "safetyStock": 10,
    "lowStock": 10,
    "segment": "Clothing",
    "region": "US",
    "counters": { "on-hand": 10 },
    "attributes": { "buy online, pick up in-store (bopis)": True }
}

headers = {
    "x-site-context": "<x-site-context>",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.text)

JavaScript Example

const options = {
  method: 'PATCH',
  headers: {
    'x-site-context': '<x-site-context>',
    Authorization: 'Bearer <token>',
    'Content-Type': 'application/json'
  },
  body: JSON.stringify({
    sku: 'SKU00025',
    itemId: 4225678911,
    locationNum: 473746,
    channelId: 12,
    vendorId: 'vendor123',
    leadTime: 1234,
    inventoryType: 'primary',
    infiniteInventory: true,
    backOrderDate: '2022-08-08T00:00:00.000Z',
    preOrderDate: '2022-08-08T00:00:00.000Z',
    backOrderLimit: 100,
    preOrderLimit: 100,
    safetyStock: 10,
    lowStock: 10,
    segment: 'Clothing',
    region: 'US',
    counters: {'on-hand': 10},
    attributes: {'buy online, pick up in-store (bopis)': true}
  })
};

fetch('https://prod01.oms.fabric.inc/api/v2/inventory', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP Example

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://prod01.oms.fabric.inc/api/v2/inventory",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "PATCH",
  CURLOPT_POSTFIELDS => json_encode([
    'sku' => 'SKU00025',
    'itemId' => 4225678911,
    'locationNum' => 473746,
    'channelId' => 12,
    'vendorId' => 'vendor123',
    'leadTime' => 1234,
    'inventoryType' => 'primary',
    'infiniteInventory' => true,
    'backOrderDate' => '2022-08-08T00:00:00.000Z',
    'preOrderDate' => '2022-08-08T00:00:00.000Z',
    'backOrderLimit' => 100,
    'preOrderLimit' => 100,
    'safetyStock' => 10,
    'lowStock' => 10,
    'segment' => 'Clothing',
    'region' => 'US',
    'counters' => ['on-hand' => 10],
    'attributes' => ['buy online, pick up in-store (bopis)' => true]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json",
    "x-site-context: <x-site-context>"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}

Response

Successful Response Code:

200 - OK

{
  "virtualCounters": {
    "availableToPurchase": 10
  },
  "id": "62272e917b12209e68751d94",
  "sku": "SKU00025",
  "itemId": 4225678911,
  "locationNum": 473746,
  "channelId": 12,
  "vendorId": "vendor123",
  "leadTime": 1234,
  "inventoryType": "Safety stock",
  "infiniteInventory": true,
  "counters": {
    "on-hand": 10
  },
  "attributes": {
    "buy online, pick up in-store (bopis)": true
  }
}

Error Responses

400 - Invalid request payload or parameter

{
  "message": "Invalid request payload or parameter"
}

404 - Resource not found

{
  "message": "Resource not found. If the issue persists please contact support@fabric.inc."
}

500 - Internal server error

{
  "message": "An internal error occurred. If the issue persists please contact support@fabric.inc."
}